# 하이브 사용량 통계 추출

## Get Started

### Python
* python 3.7.2

### CDH-Navigator 를 이용하여 사용량 통계 작성
cdh-navigator(http://ahdp138-glace.nfra.io:7187/) 에서 제공하는 Hive Operation Execution 기록을 scrape 하여 통게를 작성

#### Chrome Driver
* chrome 을 설치한다.
* 설치된 chrome 버전에 맞는 `chromedriver` 를 찾아서 설치한다.
  * https://chromedriver.chromium.org/downloads
* 기본값으로 `pdp/packages/hive-usage-statistics/chromedriver` 의 파일을 읽어서 실행한다.

#### Running
* `make run.with.cdh.nav` 혹은 IDE 에서 `cdh_nav_stats_collector` 실행
* `out/cdh-nav` 아래에 `table.md`, `checklist.md` 파일 생성됨

#### Arguments
* 원하는 설정값을 flag 로 직접 전달하여 프로그램을 실행할 수 있다.
```sh
python src/cdh_nav_stats_collector.py [-h] [--num-threads NUM_THREADS]
                                  # https://oss.navercorp.com/PDP/private/issues/102
                                  --hive-username HIVE_USERNAME
                                  --hive-password HIVE_PASSWORD
                                  [--hive-uri HIVE_URI]
                                  [--search-facet-started SEARCH_FACET_STARTED]
                                  [--search-facet-deleted SEARCH_FACET_DELETED]
                                  [--search-facet-source-type SEARCH_FACET_SOURCE_TYPE]
                                  [--search-facet-type SEARCH_FACET_TYPE]
                                  [--extra-search-facet EXTRA_SEARCH_FACET]
                                  # https://oss.navercorp.com/PDP/private/issues/6
                                  --cdh-username CDH_USERNAME --cdh-password
                                  CDH_PASSWORD [--cdh-nav-url CDH_NAV_URL]
                                  --chrome-driver-path CHROME_DRIVER_PATH
                                  [--selenium-timeout SELENIUM_TIMEOUT]
```
* flag 에 대한 설명은 `python src/cdh_nav_stats_collector.py --help` 로 확인할 수 있다.

### Hive Log 를 이용하여 사용량 통계 작성

#### Log File
C3S-PAN 의 `2022-06-03 ~ 2022-06-13` 동안의 hiveserver2 데일리 로그가 hdfs 에 저장되어 있음

`hdfs dfs -get hdfs://pgcm/user/pdd/hive_logs ./log` 명령어를 실행하여 로그파일 다운로드

#### Running
* `make` 커맨드 실행 혹은 IDE 에서 `hive_log_stats_collector` 실행
* `log` 아래 경로에 있는 `hiveserver2-yyyy-mm-dd.log` 중 `START_DATE` ~ `END_DATE` 사이에 해당하는 파일을 파싱해서 테이블 사용량을 집계하게 됨
* `out/hive-log` 아래에 `table.md`, `checklist.md` 파일 생성됨

#### Arguments
* 원하는 설정값을 flag 로 직접 전달하여 프로그램을 실행할 수 있다.
```sh
python src/hive_log_stats_collector.py [-h] [--num-threads NUM_THREADS]
                                   # https://oss.navercorp.com/PDP/private/issues/101
                                   --hive-username HIVE_USERNAME
                                   --hive-password HIVE_PASSWORD
                                   [--hive-uri HIVE_URI]
                                   [--start-date START_DATE]
                                   [--end-date END_DATE] [--log-dir LOG_DIR]
                                   [--database-filter DATABASE_FILTER]
                                   [--log-date-format LOG_DATE_FORMAT]
                                   [--table-pattern TABLE_PATTERN]
                                   [--database-pattern DATABASE_PATTERN]
```
* flag 에 대한 설명은 `python src/hive_log_stats_collector.py --help` 로 확인할 수 있다.


### Testing
`test` 디렉토리 아래의 테스트 케이스들을 실행

#### Running
* `make test` 커맨드 실행