from selenium import webdriver
from selenium.webdriver.common.by import By
from selenium.webdriver.remote.webelement import WebElement
from selenium.webdriver.support.ui import WebDriverWait
from selenium.webdriver.support import expected_conditions as ec
from typing import List, Dict


def find_elements_by_name(driver: webdriver.Chrome, *names: str) -> Dict[str, WebElement]:
    result = {}
    for name in names:
        result[name] = driver.find_element(By.NAME, name)
    return result


def find_elements_waiting_explicitly(driver: webdriver.Chrome, timeout: int, selector: str) -> List[WebElement]:
    WebDriverWait(driver, timeout).until(ec.presence_of_element_located((By.CSS_SELECTOR, selector)))
    return driver.find_elements(By.CSS_SELECTOR, selector)


def find_element_waiting_explicitly(driver: webdriver.Chrome, timeout: int, selector: str) -> WebElement:
    WebDriverWait(driver, timeout).until(ec.presence_of_element_located((By.CSS_SELECTOR, selector)))
    return driver.find_element(By.CSS_SELECTOR, selector)
