from data_util import Data, DataUsage

data_pattern = "pdd__db_(?P<service>[a-z_]+).(?P<data_type>[a-z]+)_(?P<module>[a-z0-9_]+)_(?P<version>v[0-9])"


def test_data_usage():
    data = Data.from_pattern(data_pattern, "pdd__db_booking.snapshot_booking_v2")
    data_usage = DataUsage()
    assert data_usage.get_usage_with_data(data) == 0

    data_usage.set_usage_with_data(777, data)
    assert data_usage.get_usage_with_data(data) == 777

    data_usage.set_usage_with_data(0, data)
    for i in range(50):
        data_usage.set_usage_with_data(data_usage.get_usage_with_data(data)+1, data)
        assert data_usage.get_usage_with_data(data) == i+1
